﻿using System.Configuration;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace Salient6.MvcSamples.Common.Configuration.Tests {

    [TestClass]
    public class SectionRepositoryTest {

        [TestMethod]
        public void DefaultConstructor() {
            SectionRepository target = new SectionRepository();

            Assert.IsNotNull(target);
        }

        [TestMethod]
        public void CurrentIsNotNull() {
            SectionRepository target = SectionRepository.Current;

            Assert.IsNotNull(target);
        }

        [TestMethod]
        public void GetSectionReturnsSection() {
            AliasRoutesSection section = SectionRepository.GetSection<AliasRoutesSection>(AliasRoutesSection.SectionName);

            Assert.IsNotNull(section);
        }

        [TestMethod, ExpectedException(typeof(ConfigurationErrorsException))]
        public void GetSectionThrowsExceptionWhenSectionNameDoesNotExist() {
            AliasRoutesSection section = SectionRepository.GetSection<AliasRoutesSection>("sectiondoesnotexist");
        }

        [TestMethod]
        public void AliasRoutesReturnsSection() {
            SectionRepository target = SectionRepository.Current;
            AliasRoutesSection section = target.AliasRoutes;

            Assert.IsNotNull(section);
        }
    }
}
