﻿using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace Salient6.MvcSamples.Common.Extensions.Tests {

    [TestClass]
    public class StringExtensionsTest {

        [TestMethod]
        public void HasValueReturnsTrue() {
            string value = "hasValue";

            Assert.IsTrue(StringExtensions.HasValue(value));
        }

        [TestMethod]
        public void HasValueReturnsFalseWhenValueIsNull() {
            string value = null;

            Assert.IsFalse(StringExtensions.HasValue(value));
        }

        [TestMethod]
        public void HasValueReturnsFalseWhenValueResultsInEmptyString() {
            string value = " ";

            Assert.IsFalse(StringExtensions.HasValue(value));
        }

        [TestMethod]
        public void IsEqualToReturnsTrue() {
            string left = "value";
            string right = "value";

            Assert.IsTrue(StringExtensions.IsEqualTo(left, right));
        }

        [TestMethod]
        public void IsEqualToReturnsFalse() {
            string left = "left";
            string right = "right";

            Assert.IsFalse(StringExtensions.IsEqualTo(left, right));
        }
    }
}
