﻿using System.Collections.Generic;
using System.Configuration;

namespace Salient6.MvcSamples.Common.Configuration {
    public class AliasRoutesElement : ConfigurationElement {

        [ConfigurationProperty(tokenKey, IsRequired = true)]
        public string Token {
            get { return (string)base[tokenKey]; }
        }   const string tokenKey = "token";

        [ConfigurationProperty(valueKey, IsRequired = true)]
        public string Value {
            get { return (string)base[valueKey]; }
        }   const string valueKey = "value";

        [ConfigurationProperty(aliasesKey, IsRequired = true)]
        public string AliasesRawValue {
            get { return (string)base[aliasesKey]; }
        }   const string aliasesKey = "aliases";

        public List<string> Aliases {
            get {
                if(this._aliases == null) {
                    this._aliases = new List<string>();
                    string rawValue = this.AliasesRawValue.ToLower().Replace(" ", string.Empty);

                    if(rawValue.Length > 0) this._aliases.AddRange(rawValue.Split(','));
                }

                return _aliases;
            }
        }   private List<string> _aliases;

        public bool ContainsAlias(string alias) {
            return this.Aliases.Contains(alias.ToLower());
        }
    }
}
