﻿using System.Configuration;

namespace Salient6.MvcSamples.Common.Configuration {

    public class SectionRepository {
        private static object currentLock = new object();

        public static SectionRepository Current {
            get {
                if (_current == null) {
                    lock (currentLock) {
                        _current = new SectionRepository();
                    }
                }

                return _current;
            }
        }   private static SectionRepository _current;

        public AliasRoutesSection AliasRoutes {
            get {
                if(this._aliasRoutes == null) {
                    this._aliasRoutes = SectionRepository.GetSection<AliasRoutesSection>(AliasRoutesSection.SectionName);
                }

                return this._aliasRoutes;
            }
        }   private AliasRoutesSection _aliasRoutes;

        public static T GetSection<T>(string sectionName) where T : ConfigurationSection {
            ConfigurationManager.RefreshSection(sectionName);
            T section = ConfigurationManager.GetSection(sectionName) as T;

            if(section == null) {
                string message = string.Format("Please ensure the following configuration section exists: '{0}'", sectionName);

                throw new ConfigurationErrorsException(message);
            }

            return section;
        }
    }
}

